/*H file for UART2 courtesy of Brian Toth of Cornell Baja SAE*/

// Code used in Michael Kilzer's (mjk277) Cornell University MEng Project.

#ifndef UART_H_
#define UART_H_

#include <stdint.h>
#include "definitions.h"

#define TX_SIZE2 512

// ***********************
// Function to set up UART
void UART2_Init(int baudrate, receive_func interrupt_function);

/*
 * r: 0 for success, -1 for insufficient space
 */
int8_t UART2_Sendchar(char c);

// ***********************
// Function to get character from UART
char UART2_Getchar();

// ***********************
// Function to prints the string out over the UART
int8_t UART2_PrintString(char *pcString);

// ***********************
// Function to handle UART interrupts
void UART2_IRQHandler (void);

/*
 * Get the next string with provided delimiter, up to sizeof(target)-1
 * The last byte is used for the null terminator.  if no delimiter is found,
 * a 0 is returned (indicating an error)
 *
 * returns number of bytes actually acquired, not including the null terminator
 * 0 indicates an error
 */
int8_t UART2_Getstr(uint8_t* target, uint8_t size, const uint8_t* delimiter);

int8_t UART2_is_not_Ready();

#endif /*UART_H_*/
